unit atm;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls;

type
  TBankForm = class(TForm)
    LogoPanel: TPanel;
    HelpPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    HelpLabel: TLabel;
    ContButton2: TButton;
    TransPanel: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    procedure FormCreate(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure RadioButton4Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
  private
    { Private declarations }
    procedure transaction(ok: boolean);
  public
    { Public declarations }
  end;

var
  BankForm: TBankForm;

implementation

uses welcome, farewell;

{$R *.dfm}

type
    account = record
        number : integer;
        pin : integer;
        balance : real;
        end;

var 	custdata : file of account;
        customer : array[1..10] of account;
        count, cust : integer;

procedure TBankForm.transaction(ok: boolean);
//Display transaction screen if valid account found
begin
      if ok then
         begin
         HelpPanel.Caption := 'Select transaction';
         TransPanel.Show;
         end  {then}
      else
         begin
         ShowMessage('No valid account found') ;
         ContButton2.visible := true;;
      end;    {else}
end;   {transaction}

procedure TBankForm.FormCreate(Sender: TObject);
//Read customer data from disc
begin
     AssignFile(custdata, 'cust.dat');
     reset(custdata);
     count := 0;
     while not eof(custdata) do
        begin
        count := count + 1;
        read(custdata, customer[count]);
        end;
end;

procedure TBankForm.FormActivate(Sender: TObject);
//Verify if user account and PIN match disc data
var  go, j, acctry , pintry : integer;
     cont : boolean;
begin
     go := 0;
     cont := false;
     while (go < 3) and not cont do             //three attempts to get PIN correct
        begin
        go := go + 1;
        HelpLabel.Caption := 'Attempt ' + IntToStr(go) + ' - five digit Account number';
	acctry := StrToInt(InputBox('Account Number', 'Enter Account Number', ''));
	HelpLabel.Caption := 'Attempt ' + IntToStr(go) + ' - three digit PIN';
	pintry := StrToInt(InputBox('Personal Identification Number', 'Enter PIN', ''));
 	for j := 1 to count do
            if (customer[j].number = acctry) and (customer[j].pin = pintry) then
		begin                         //compare input to data read from disc
	        cont := true;
	        cust := j;
	        end;  {if}
	end;   {while}
     HelpLabel.Caption := '';
     transaction(cont);
end;   {verify}

procedure TBankForm.RadioButton4Click(Sender: TObject);
//Save data to disc and close account file
var j : integer;
begin
     beep;
     rewrite(custdata);
     for j := 1 to count do
         write(custdata, customer[j]);
     CloseFile(custdata);
     BankForm.Hide;
     FarewellForm.Show;
end;

procedure TBankForm.RadioButton1Click(Sender: TObject);
//Display customer balance
var balance : string;
begin
     beep;
     balance := FloatToStrF(customer[cust].balance, ffCurrency, 6,2);
     MessageDlg(balance, mtConfirmation, mbOKCancel, 0);
end;

procedure TBankForm.RadioButton2Click(Sender: TObject);
//Deposit to customer account
var amount : real;
begin
     beep;
     amount := -1;
     HelpLabel.Caption := 'Enter amount to deposit without a $ sign';
     while amount < 0 do
         amount := StrToFloat(InputBox('Deposit' ,'Amount?', '0'));
     customer[cust].balance := customer[cust].balance + amount;
     HelpLabel.Caption := 'Select transaction';
end;

procedure TBankForm.RadioButton3Click(Sender: TObject);
//Withdraw from customer account
var amount : real;
begin
     beep;
     amount := -1;
     HelpLabel.Caption := 'Enter amount to withdraw without a $ sign';
     while (amount < 0) or (amount > 500) do
         amount := StrToFloat(InputBox('Withdrawal', 'Amount? (Max $500)', '100'));
     if amount > customer[cust].balance then
         MessageDlg('Amount greater than balance of account', mtWarning, [mbOK, mbCancel], 0)
     else
         customer[cust].balance := customer[cust].balance - amount;
     HelpLabel.Caption := 'Select transaction';
end;

end.
